Morph subclass: #FitnessMapMorph
	instanceVariableNames: 'ga lines form hasChanged '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Genetic-Morphs'!
!FitnessMapMorph commentStamp: 'DGD 11/27/2000 19:16' prior: 0!
I draw the evolution of a GA!


!FitnessMapMorph methodsFor: 'drawing' stamp: 'DGD 12/1/2000 00:35'!
drawForm
	| newForm afitness maxFitness minFitness black |
	maxFitness _ lines anyOne anyOne.
	minFitness _ maxFitness.
	lines do: 
		[:line | 
		maxFitness _ maxFitness max: line max.
		minFitness _ minFitness min: line min].
	afitness _ maxFitness - minFitness.
	newForm _ 
	Form extent: lines size @ lines anyOne size depth: 32.
	black _ Color black.
	lines withIndexDo: [:line :x | line withIndexDo: [:fitness :y | newForm colorAt: (Point x: x - 1 y: y - 1)
				put: (color mixed: fitness - minFitness / afitness with: black)]].
	form _ newForm! !

!FitnessMapMorph methodsFor: 'drawing' stamp: 'DGD 12/1/2000 00:48'!
drawOn: aCanvas 
	| morphSize formSize newForm |
	"super drawOn: aCanvas."
	morphSize _ bounds extent.
	formSize _ form extent.
	newForm _ morphSize = formSize
				ifTrue: [form]
				ifFalse: 
					[| scale | 
					scale _ morphSize x / formSize x min: morphSize y / formSize y.
					form magnifyBy: scale].
	aCanvas image: newForm at: bounds origin! !


!FitnessMapMorph methodsFor: 'stepping' stamp: 'DGD 12/1/2000 00:34'!
step
	super step.
	hasChanged
		ifTrue: 
			[hasChanged _ false.
			"self extent: lines size @ lines anyOne size."
			self drawForm.
			self changed]! !


!FitnessMapMorph methodsFor: 'genetic' stamp: 'DGD 11/25/2000 02:05'!
addFitness: newFitnesses 

	lines add: newFitnesses.
	hasChanged _ true! !


!FitnessMapMorph methodsFor: 'initialization' stamp: 'DGD 12/1/2000 00:35'!
initialize
	super initialize.
	lines _ OrderedCollection new.
	form _ Form extent: self extent depth: 32.
	hasChanged _ false.
	self color: Color white! !


AlignmentMorph subclass: #GeneticAlgorithmMorph
	instanceVariableNames: 'ga fitnessMapMorph fitnessMorph bestIndividueMorph generationMorph elapsedTimeMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Genetic-Morphs'!
!GeneticAlgorithmMorph commentStamp: 'DGD 11/27/2000 19:14' prior: 0!
I'm a Mediator between GeneticAlgorithm and the Morphs!


!GeneticAlgorithmMorph methodsFor: 'accessing' stamp: 'DGD 11/24/2000 20:13'!
ga: aGA 
	ga isNil ifFalse: [ga removeDependent: self].
	aGA addDependent: self.
	ga _ aGA! !


!GeneticAlgorithmMorph methodsFor: 'genetic' stamp: 'DGD 12/1/2000 16:31'!
update: aSymbol 
	aSymbol == #population
		ifTrue: 
			[| fs elapsedTime generation | 
			fs _ ga population fitnessStatistics.
			generation _ ga population generation.
			elapsedTime _ Time now subtractTime: ga start.
			generationMorph contents: generation printString.
			elapsedTimeMorph contents: elapsedTime intervalString , ' (' , (1000.0 * elapsedTime asSeconds / generation) rounded printString , 'ms/generation)'.
			fitnessMorph serie: #max add: generation @ fs maxFitness.
			fitnessMorph serie: #average add: generation @ fs averageFitness.
			fitnessMorph serie: #min add: generation @ fs minFitness.
			fitnessMapMorph addFitness: fs fitnesses shuffled].
	aSymbol == #bestIndividue ifTrue: [bestIndividueMorph contents: ga bestIndividue printString
		"fitness"]! !


!GeneticAlgorithmMorph methodsFor: 'initialization' stamp: 'DGD 12/1/2000 00:21'!
initialize
	super initialize.
	self orientation: #vertical;
	 hResizing: #shrinkWrap;
	 vResizing: #shrinkWrap;
	 borderWidth: 2;
	 color: Color black;
	 borderColor: Color white;
	 inset: 3.
	self createTitle: 'Statistics'.
	self createStatistics.
	self createSpace.
	self createTitle: 'Best Individue'.
	self createBestIndividueMorph.
	self createSpace.
	self createTitle: 'Fitness Evolution'.
	self createFitnessMorph.
	self createSpace.
	self createTitle: 'Fitness Map'.
	self createFitnessMapMorph.
! !


!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 12/1/2000 00:25'!
addContent: anObject 
	| container |
	container _ AlignmentMorph newRow color: Color transparent;
			 borderWidth: 1;
			 borderColor: self borderColor twiceDarker;
			 inset: 1;
			 hResizing: #spaceFill;
			 vResizing: #shrinkWrap.
	container addMorphBack: anObject.
	self addMorphBack: container! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 11/30/2000 02:42'!
createBestIndividueMorph
	bestIndividueMorph _ StringMorph contents: '.'.
bestIndividueMorph color: Color white.
	self addContent: bestIndividueMorph! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 12/1/2000 00:44'!
createFitnessMapMorph
	fitnessMapMorph _ FitnessMapMorph new extent: 900 @ 150;
color: Color yellow;
			 yourself.
	self addContent: fitnessMapMorph! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 12/1/2000 00:42'!
createFitnessMorph
	fitnessMorph _ PlotMorph new color: Color transparent;
			 serie: #max color: Color blue;
			 serie: #average color: Color red;
			 serie: #min color: Color green;
			 extent: 900 @ 350;
			 yourself.
	self addContent: fitnessMorph! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 11/29/2000 00:20'!
createSpace
	self addMorphBack: (StringMorph contents: '').! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 12/1/2000 00:32'!
createStatistics
	| statistics line1 line2 white |
	white _ Color white.
	generationMorph _ (StringMorph contents: '')
				color: white.
	elapsedTimeMorph _ (StringMorph contents: '')
				color: white.
	line1 _ AlignmentMorph newRow color: Color transparent.
	line1 addMorphBack: ((StringMorph contents: 'Generation Number: ')
			color: white).
	line1 addMorphBack: generationMorph.
	line2 _ AlignmentMorph newRow color: Color transparent.
	line2 addMorphBack: ((StringMorph contents: 'Elapsed Time:')
			color: white).
	line2 addMorphBack: elapsedTimeMorph.
	statistics _ AlignmentMorph newColumn color: Color transparent.
statistics inset:0.
	statistics addMorphBack: line1.
	statistics addMorphBack: line2.
	self addContent: statistics! !

!GeneticAlgorithmMorph methodsFor: 'private' stamp: 'DGD 12/1/2000 00:33'!
createTitle: aString 
	| s |
	s _ StringMorph contents: aString font: (StrikeFont familyName: #DefaultTextStyle size: 18).
	s color: Color white.
	self addMorphBack: s! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GeneticAlgorithmMorph class
	instanceVariableNames: ''!

!GeneticAlgorithmMorph class methodsFor: 'instance creation' stamp: 'DGD 11/28/2000 23:19'!
newOn: aGeneticAlgorithm 
	^ self new ga: aGeneticAlgorithm;
	 yourself! !


Morph subclass: #PlotMorph
	instanceVariableNames: 'series colors drawGrid drawCotas '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Genetic-Morphs'!
!PlotMorph commentStamp: 'DGD 12/2/2000 01:38' prior: 0!
I can draw many series of Points in a XY grid!


!PlotMorph methodsFor: 'accessing' stamp: 'DGD 12/2/2000 01:56'!
drawCotas: anObject 
anObject = drawCotas ifFalse:[
	drawCotas _ anObject. self changed]! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 12/2/2000 01:53'!
drawGrid: anObject 
	anObject = drawGrid
		ifFalse: 
			[drawGrid _ anObject.
			self changed]! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 11/30/2000 22:32'!
serie: aSymbol add: aPoint 
	| points |
	points _ series at: aSymbol ifAbsentPut: [OrderedCollection new].
	points add: aPoint.
	self changed! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 11/30/2000 01:00'!
serie: aSymbol color: aColor
	colors at:aSymbol put: aColor.
	self changed! !


!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/2/2000 01:46'!
drawCotasOn: aCanvas 
	| cotaColor string |
	cotaColor _ color twiceLighter .
	string _ 'X=' , self minPoint x printString , '/' , self maxPoint x printString , '  Y=' , self minPoint y printString , '/' , self maxPoint y printString.
	aCanvas
		text: string
		bounds: (bounds insetBy: 2)
		font: nil
		color: cotaColor! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/2/2000 01:05'!
drawGridOn: aCanvas 
	| gridColor left right width top bottom height |
	gridColor _ color lighter  alpha: 0.5.
	left _ self bounds left.
	right _ self bounds right - 1.
	width _ self bounds width - 1.
	top _ self bounds top.
	bottom _ self bounds bottom - 1.
	height _ self bounds height - 1.
	left
		to: right
		by: width / 10
		do: 
			[:x | 
			x _ x truncated.
			aCanvas
				line: x @ top
				to: x @ bottom
				color: gridColor].
	top
		to: bottom
		by: height / 10
		do: 
			[:y | 
			y _ y truncated.
			aCanvas
				line: left @ y
				to: right @ y
				color: gridColor]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/2/2000 01:57'!
drawOn: aCanvas 
	| scaledPoints |
	super drawOn: aCanvas.
	drawGrid ifTrue: [self drawGridOn: aCanvas].
	drawCotas ifTrue:[self drawCotasOn: aCanvas].
	series
		keysAndValuesDo: 
			[:serie :points | 
			scaledPoints _ self scalePoints: points.
			scaledPoints == nil
				ifFalse: [self
						drawOn: aCanvas
						serie: scaledPoints
						color: (colors at: serie ifAbsent: [Color black])]]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/2/2000 01:49'!
drawOn: aCanvas serie: aSerie color: aColor 
	| lineColor ovalColor lastPoint |
	lineColor _ aColor alpha: 0.5.
	ovalColor _ aColor twiceLighter alpha: 0.5.
	lastPoint _ aSerie first.
	aSerie do: 
		[:point | 
		aCanvas
			line: lastPoint
			to: point
			color: lineColor.
		aCanvas fillRectangle: (point - (1 @ 1) rect: point + (2 @ 2))
			color: ovalColor.
		lastPoint _ point]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 11/30/2000 23:50'!
maxPoint
	| maxPoint |
series size = 0 ifTrue:[^ 0@0] ifFalse:[
	maxPoint _ series anyOne max.
	series valuesDo: [:points | maxPoint _ maxPoint max: points max].
	^ maxPoint]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 11/30/2000 23:50'!
minPoint
	| minPoint |
series size = 0
		ifTrue: [^ 0 @ 0]
		ifFalse: 
			[
	minPoint _ series anyOne min.
	series valuesDo: [:points | minPoint _ minPoint min: points min].
	^ minPoint]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 11/30/2000 23:20'!
scalePoints: aPointCollection 
	| rect1 rect2 tempPoint |
	rect1 _ 0 @ 0 rect: self maxPoint - self minPoint.
	^ rect1 area = 0
		ifFalse: 
			[
			rect2 _ 2 @ 2 rect: self extent - (2 @ 2).
			aPointCollection
				collect: 
					[:point | 
					tempPoint _ point - self minPoint scaleFrom: rect1 to: rect2.
					self left + tempPoint x @ (self bottom - tempPoint y)]]! !


!PlotMorph methodsFor: 'geometry' stamp: 'DGD 12/3/2000 13:31'!
extent:aPoint
super extent:(aPoint max: (50@50))! !


!PlotMorph methodsFor: 'initialization' stamp: 'DGD 12/2/2000 01:57'!
initialize
	super initialize.
	self color: Color white.
	series _ Dictionary new.
	colors _ Dictionary new.
	drawGrid _ true.
drawCotas _ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PlotMorph class
	instanceVariableNames: ''!

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 11/30/2000 03:02'!
test
	| pm |
	pm _ PlotMorph new.
	pm extent: 250 @ 250.
	pm color: (Color black alpha: 0.5).
	pm serie: #sin color: Color red.
	pm serie: #cos color: Color blue.
	pm serie: #squared color: Color green.
	pm serie: #test color: Color yellow.
	0
		to: 360
		by: 10
		do: [:x | pm serie: #sin add: x @ (5000 * x degreesToRadians sin) asInteger].
	0
		to: 360
		by: 10
		do: [:x | pm serie: #cos add: x @ (5000 * x degreesToRadians cos) asInteger].
	0
		to: 360
		by: 10
		do: [:x | pm serie: #test add: x @ (5000 * (x degreesToRadians cos + x degreesToRadians sin)) asInteger].
	0
		to: 100
		by: 10
		do: [:x | pm serie: #squared add: x * 2 @ x squared asInteger].
	pm openInWorld! !

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 11/30/2000 01:07'!
test1
	| pm |
	pm _ PlotMorph new.
	pm serie: #squared color: Color green.
	0
		to: 100
		by: 10
		do: [:x | pm serie: #squared add: x @ x squared asInteger].
	pm openInWorld! !
